import { type DatabaseConnection, type QueryResult, type SqliteDatabase, SqliteDialect, type SqliteDialectConfig, SqliteDriver } from 'kysely';
declare class LibSqlConnection implements DatabaseConnection {
    private readonly db;
    private readonly created;
    memory: boolean;
    constructor(db: SqliteDatabase);
    isValid(): boolean;
    executeQuery<R>(compiledQuery: any): Promise<QueryResult<R>>;
    streamQuery<R>(compiledQuery: any): AsyncIterableIterator<QueryResult<R>>;
}
declare class LibSqlKyselyDriver extends SqliteDriver {
    private readonly config;
    private db;
    private connection;
    private connectionMutex;
    constructor(config: SqliteDialectConfig);
    init(): Promise<void>;
    acquireConnection(): Promise<LibSqlConnection>;
    releaseConnection(): Promise<void>;
    destroy(): Promise<void>;
}
export declare class LibSqlDialect extends SqliteDialect {
    private readonly config;
    constructor(config: SqliteDialectConfig);
    createDriver(): LibSqlKyselyDriver;
}
export {};
